// tNXDayyRŁz

public class Day {
	private int year  = 1;		// N
	private int month = 1;		// 
	private int date  = 1;		// 

	//--- RXgN^ ---//
	public Day()                              { }
	public Day(int year)                      { this.year = year; }
	public Day(int year, int month)           { this(year); this.month = month; }
	public Day(int year, int month, int date) { this(year, month); this.date = date; }
	public Day(Day d)                         { this(d.year, d.month, d.date); }

	//--- NEE擾 ---//
	public int getYear()  { return year; }		// N
	public int getMonth() { return month; }		// 
	public int getDate()  { return date; }		// 

	//--- NEEݒ ---//
	public void setYear(int year)   { this.year  = year; }		// N
	public void setMonth(int month) { this.month = month; }		// 
	public void setDate(int date)   { this.date  = date; }		// 

	public void set(int year, int month, int date) {	// N
		this.year  = year;			// N	
		this.month = month;			// 
		this.date  = date;			// 
	}

	//--- j߂ij`yj0`6ŕԋpj --//
	int dayOfWeek() {
		int y = year;
		int m = month;
		if (m == 1 || m == 2) {
			y--;
			m += 12;
		}
		return (y + y / 4 - y / 100 + y / 400 + (13 * m + 8) / 5 + date) % 7;
	}

	//--- tdƓ ---//
	public boolean equalTo(Day d) {
		return year == d.year && month == d.month && date == d.date;
	}

	//--- \ԋp ---//
	public String toString() {
		String[] wd = {"", "", "", "", "", "", "y"};
		return String.format("%04dN%02d%02d(%s)",
														year, month, date, wd[dayOfWeek()]);
	}
}
