// tNXDayyTŁz

public class Day {
	private int year  = 1;		// N
	private int month = 1;		// 
	private int date  = 1;		// 

	//--- yN͉[NH ---//
	public static boolean isLeap(int y) {
		return y % 4 == 0 && y % 100 != 0 || y % 400 == 0;
	}

	//--- [NH ---//
	public boolean isLeap() { return isLeap(year); }

	//-- RXgN^ --//
	public Day()                              { }
	public Day(int year)                      { this.year = year; }
	public Day(int year, int month)           { this(year); this.month = month; }
	public Day(int year, int month, int date) { this(year, month); this.date = date; }
	public Day(Day d)                         { this(d.year, d.month, d.date); }

	//--- NEE擾 ---//
	public int getYear()  { return year; }		// N擾
	public int getMonth() { return month; }	// 擾
	public int getDay()   { return date; }		// 擾

	//--- NEEݒ ---//
	public void setYear(int year)   { this.year  = year; }	// Nݒ
	public void setMonth(int month) { this.month = month; }	// ݒ
	public void setDate(int date)   { this.date  = date; }	// ݒ

	public void set(int year, int month, int date) {			// N
		this.year  = year;			// N	
		this.month = month;			// 
		this.date  = date;			// 
	}

	//--- j߂ ---//
	public int dayOfWeek() {
		int y = year;					// 0 c j
		int m = month;					// 1 c j
		if (m == 1 || m == 2) {		//@ F
			y--;							// 5 c j
			m += 12;						// 6 c yj
		}
		return (y + y / 4 - y / 100 + y / 400 + (13 * m + 8) / 5 + date) % 7;
	}

	public int hashCode() {
		return (year * 372) + (month * 31) + date;
	}

	public boolean equals(Object obj) {
		if (this == obj)					// rΏۂgł΁c
			return true;
		if (obj instanceof Day) {	// objDayNXỉʃNXj^ł΁c
			Day d = (Day)obj;
			return (year == d.year && month == d.month && date == d.date) ? true
																																		: false;
		}
		return false;
	}

	//--- \ԋp ---//
	public String toString() {
		String[] wd = {"", "", "", "", "", "", "y"};
		return String.format("%04dN%02d%02d(%s)", 
										year, month, date, wd[dayOfWeek()]);
	}
}
